Subject: Re: [bpf-next V2 PATCH 10/15] xdp: rhashtable with allocator ID to pointer mapping

From: Jesper Dangaard Brouer <[email-masked]>
Date: Mon, 19 Mar 2018 10:48:58 +0100

On Fri, 16 Mar 2018 16:45:30 +0800
Jason Wang <[email-masked]> wrote:

> On 2018年03月10日 00:07, Jesper Dangaard Brouer wrote:
> > On Fri, 9 Mar 2018 21:07:36 +0800
> > Jason Wang <[email-masked]> wrote:
> >  
> >>>>> Use the IDA infrastructure for getting a cyclic increasing ID number,
> >>>>> that is used for keeping track of each registered allocator per
> >>>>> RX-queue xdp_rxq_info.
> >>>>>
> >>>>> Signed-off-by: Jesper Dangaard Brouer<[email-masked]>  
> >>>> A stupid question is, can we manage to unify this ID with NAPI id?  
> >>> Sorry I don't understand the question?
> >>
> >> I mean can we associate page poll pointer to napi_struct, record NAPI id
> >> in xdp_mem_info and do lookup through NAPI id?  
> >
> > No. The driver can unreg/reg a new XDP memory model,  
> 
> Is there an actual use case for this?

I believe this is the common use case.  When attaching an XDP/bpf prog,
then the driver usually want to change the RX-ring memory model
(different performance trade off).  When detaching XDP, then driver
want to change back to old memory model. During this process, I
believe, the NAPI-ID remains the same (right?).

> >   without reloading
> > the NAPI and generate a new NAPI id.
> >  
-- 
Best regards,
  Jesper Dangaard Brouer
  MSc.CS, Principal Kernel Engineer at Red Hat
  LinkedIn: http://www.linkedin.com/in/brouer